<?php 

define('EXEC_EZT', true);
$ezt_root_path='.';
include("./common.php");

$input_selection = array_merge($_POST, $_GET);

$login_url = $config['baseurl'] . $_SERVER['url'];
page_open(array("sess" => "ezt_Session", "auth" => "ezt_Default_Auth"));

// Set Skin
include("./select-skin.php");

$q = new ezt_db;
$t = new Template($selected_skin['path']);
//$t->debug = 7; /* activate for full debugging */

$t->set_file("page", $selected_skin['ezt-list']);
$Page_name = "EZTicket List";
$headerout=makeheader($q, "$Page_name");
$footerout=makefooter();
                                                                                                                                       
// touch user record for last login time
$user_update['where'] = array("user_id" => $auth->auth['uid']);
$user_update['user_last_login'] = "NOW()";
ezt_record($q, "ezt_users", $user_update, UPDATE);

// ************************
// *** Create Ticket List
// ************************

  // Parse sumitted argvs
  extract(special_query($q, $input_selection));

  // Get tickets
  $query = sprintf("SELECT 
	ticket_owner_username, 
	ticket_owner_id, 
	ticket_id, 
	ticket_status, 
	ticket_priority, 
	ticket_severity, 
	ticket_category, 
	DATE_FORMAT(ticket_open_date, '%%m-%%d-%%y') AS ticket_open_date, 
	UNIX_TIMESTAMP(ticket_open_date) AS ticket_age_seconds, 
	UNIX_TIMESTAMP(ticket_last_update) AS ticket_update_age_seconds, 
	ticket_creator_username, 
	ticket_creator_id, 
	ticket_updater_username, 
	ticket_updater_id, 
	ticket_title,
        ticket_sticky
	FROM 
	ezt_tickets
	%s %s %s %s %s %s", $join_string, $special_query_string, $special_order, $group_string, $order_string, $query_limit_sql);
  $ticket_list = lookup_record($q, $query);

  $sticky_ticket_list = get_sticky_tickets($q, $auth->auth['uid']);

  $query = sprintf("SELECT 
	COUNT(ticket_id) 
	FROM ezt_tickets
	%s %s", $join_string, $special_query_string);
  $total_tickets = array_pop(array_pop(lookup_record($q, $query)));

  // Generate page link HTML
  $pagelink_html = page_calc_html($total_tickets, $current_page, $query_limit, $_SERVER["QUERY_STRING"]);

  // Send a reminder to close DONE tickets, if we have any in our box
  if (is_array($input_selection['owner'])) {
    if (!isset($_COOKIE['ezt_done_reminder_' . $auth->auth['uid']]) && in_array($auth->auth['uid'], $input_selection['owner'])) {
      $donetickets = multi_array_match(array("ticket_owner_id" => $auth->auth['uid'], "ticket_status" => DONE), $ticket_list);
      if ($donetickets) {
        $t->set_var("DONE_REMINDER_JAVASCRIPT", popup_message(sprintf("You have %s DONE Tickets in your box.  Please CLOSE them.", count($donetickets))));
        setcookie("ezt_done_reminder_" . $auth->auth['uid'], "1", time()+$config['remindertime']);
      }
    }
  }

  // Set cosmetic information in the template
  $t->set_var(array("TOTAL_TICKETS_DISPLAYED" => count($ticket_list),
		    "TOTAL_SELECTED_TICKETS" => $total_tickets,
		    "EXPORT_EXCEL_URL" => export_url($_SERVER["QUERY_STRING"]),
		    "PAGEJUMP_LINK" => $pagelink_html));

  $t->set_var($template_replace);

  // start parsing template to show tickets
  $t->set_block("page", "ezt-list", "tickets");
  $ticketcount = 1;

  // Display unupdated sticky tickets and send message if needed
  if(!empty($sticky_ticket_list)) {
    while ($element = array_shift($sticky_ticket_list)) {;
      $element['ticket_sticky_html'] = sprintf("<IMG ALT=\"Sticky Ticket\" SRC=\"%s/%s\">", $selected_skin['imageurl'], $selected_skin['sticky_icon']);
      $element['ticket_age'] = age_calc(date("U") - $element['ticket_age_seconds']);
      $element['ticket_link'] = sprintf("%s/ezt.php?ticket=%s", $config['baseurl'], $element['ticket_id']);
      $element['ticket_status_html'] = ezt_status_html($element['ticket_status']);
      $element['ticket_severity_html'] = ezt_severity_html($element['ticket_severity']);
      $element['ticket_priority_html'] = ezt_priority_html($element['ticket_priority']);
      $element['ticket_owner_username_html'] = "UNACKED TICKET";
      $element['ticket_creator_username_html'] = $element['ticket_creator_username'];
      $element['ticket_updater_username_html'] = $element['ticket_updater_username'];
      if($ticketcount % 2 == 0) 
        $element['rowcss'] = "evenrow";
      else
        $element['rowcss'] = "oddrow";
      $element['rownum'] = $ticketcount;
      $t->set_var(upper_key($element));
      $t->parse("tickets", "ezt-list", true);
      $ticketcount++;
    }
    $t->set_var("STICKY_JAVASCRIPT", popup_message("You have UNACKNOWLEDGED Sticky Tickets.  Please update them."));
  }

  // Display regular tickets
  while ($element = array_shift($ticket_list)) {;
    if($element['ticket_sticky'] == 1)
      $element['ticket_sticky_html'] = sprintf("<IMG ALT=\"Sticky Ticket\" SRC=\"%s\">", $selected_skin['sticky_icon']);
    else
      $element['ticket_sticky_html'] = "";
    if($element['ticket_status'] == CLOSED)
      $element['ticket_age'] = age_calc(date("U") - $element['ticket_age_seconds']);
    else
      $element['ticket_age'] = age_calc(date("U") - $element['ticket_update_age_seconds']);
    $element['ticket_link'] = sprintf("%s/ezt.php?ticket=%s", $config['baseurl'], $element['ticket_id']);
    $element['ticket_status_html'] = ezt_status_html($element['ticket_status']);
    $element['ticket_severity_html'] = ezt_severity_html($element['ticket_severity']);
    $element['ticket_priority_html'] = ezt_priority_html($element['ticket_priority']);
    if(isset($input_selection['owner']))
      $element['ticket_owner_username_html'] = ezt_user_html($input_selection['owner'], $element['ticket_owner_username'], $element['ticket_owner_id']);
    else
      $element['ticket_owner_username_html'] = ezt_user_html($auth->auth['uid'], $element['ticket_owner_username'], $element['ticket_owner_id']);
    if(isset($input_selection['owner']) && !in_array($element['ticket_owner_id'], $input_selection['owner']))
      $element['ticket_escalation_html'] = sprintf("<IMG ALT=\"Escalated Ticket\" SRC=\"%s\">", $selected_skin['escalation_icon']);
    else
      $element['ticket_escalation_html'] = "";
    $element['ticket_creator_username_html'] = $element['ticket_creator_username'];
    $element['ticket_updater_username_html'] = $element['ticket_updater_username'];
    if($ticketcount%2 == 0) 
      $element['rowcss'] = "evenrow";
    else
      $element['rowcss'] = "oddrow";
    $element['rownum'] = $ticketcount;
    $t->set_var(upper_key($element));
    $t->parse("tickets", "ezt-list", true);
    $ticketcount++;
  }
  reset($ticket_list);

// ************************
// *** Create Ticket List Header
// ************************

  $user_list = lookup_record($q, "SELECT user_id, user_username FROM ezt_users ORDER BY user_username");
                                                                                                                                       
  // Owner list
  reset($user_list);
  $t->set_block("page", "owner-user-list", "owner-users");
  while (list($key, $element) = each($user_list)) {;
    if(in_array($element['user_id'], $selected_owner_id)) {
      $element['OWNER_SELECTED'] = "SELECTED";
    } else
      $element['OWNER_SELECTED'] = "";
    $t->set_var(upper_key($element));
    $t->parse("owner-users", "owner-user-list", true);
  }

  // Creator list
  reset($user_list);
  $t->set_block("page", "creator-user-list", "creator-users");
  while (list( $key, $element) = each($user_list)) {;
    if(in_array($element['user_id'], $selected_creator_id))
      $element['CREATOR_SELECTED'] = "SELECTED";
    else
      $element['CREATOR_SELECTED'] = "";
    $t->set_var(upper_key($element));
    $t->parse("creator-users", "creator-user-list", true);
  }

  // Updater list
  reset($user_list);
  $t->set_block("page", "updater-user-list", "updater-users");
  while (list( $key, $element) = each($user_list)) {;
    if(in_array($element['user_id'], $selected_updater_id))
      $element['UPDATER_SELECTED'] = "SELECTED";
    else
      $element['UPDATER_SELECTED'] = "";
    $t->set_var(upper_key($element));
    $t->parse("updater-users", "updater-user-list", true);
  }

  // Severity
  $t->set_block("page", "severity-list", "severities");
  foreach($severity_levels as $key => $sev) {
    if($selected_severity == $sev)
      $t->set_var("SEVERITY_SELECTED", "SELECTED");
    else
      $t->set_var("SEVERITY_SELECTED", "");
    $t->set_var("SEVERITY", $sev);
    $t->parse("severities", "severity-list", true);
  }
                                                                                                                                                        
  // Priority
  $t->set_block("page", "priority-list", "priorities");
  foreach($priority_levels as $key => $sev) {
    if($selected_priority == $sev)
      $t->set_var("PRIORITY_SELECTED", "SELECTED");
    else
      $t->set_var("PRIORITY_SELECTED", "");
    $t->set_var("PRIORITY", $sev);
    $t->parse("priorities", "priority-list", true);
  }


  $t->set_var(array( "TOTAL_TICKETS" => array_shift(array_shift(lookup_record($q, "SELECT COUNT(ticket_id) FROM ezt_tickets"))),
                     "TOTAL_OPEN_TICKETS" => array_shift(array_shift(lookup_record($q, sprintf("SELECT COUNT(ticket_id) FROM ezt_tickets WHERE ticket_status = %s", OPEN)))),
                     "TOTAL_DONE_TICKETS" => array_shift(array_shift(lookup_record($q, sprintf("SELECT COUNT(ticket_id) FROM ezt_tickets WHERE ticket_status = %s", DONE)))),
                     "TOTAL_CLOSED_TICKETS" => array_shift(array_shift(lookup_record($q, sprintf("SELECT COUNT(ticket_id) FROM ezt_tickets WHERE ticket_status = %s", CLOSED))))));


  $t->set_var(array("HEADER" => $headerout,
                    "FOOTER" => $footerout,
                    "BASEURL" => $config['baseurl']));
  $t->parse("pageout", "page");
  $output=$t->retp("pageout");
  if($config['templatedebug']) {
     $output .= "Undefied template variables in page:" . @implode(", ", $t->get_undefined("pageout"));
  }
  print $output;

  // Save data back to database.
  page_close()
?>
