<?php


define('INSERT', 1);
define('UPDATE', 2);
define('DELETE', 3);

function ezt_record($dbh, $table, $record, $mode) {

  if( array_key_exists("where", $record) ) {
    foreach ($record['where'] as $key => $val) {
    //while (list($key, $val)=array_pop($record['where'])) {
      $where .= sprintf("%s=%s", $key, $val);
      if( count($record['where']) > 1 )
        $where .= " AND ";
      array_shift($record['where']);
    } 
    unset($record['where']);
  }

  $count=count($record);
  while (list($key, $val)=each($record)) {
    $setpairs .= sprintf("%s=%s", $key, $val);
    if( $count > 1 ) {
      $setpairs .= ", ";
    }
    $count--;
  } 

  switch($mode) {
  case 1: // INSERT
    if(empty($setpairs)) {
      die("ezt_record: Empty SET, aborted.");
    }
    $query = sprintf("INSERT INTO %s SET %s", $table, $setpairs);
    $dbh->query($query);
    // Get id number to return
    $query = "SELECT LAST_INSERT_ID()";
    if(!$dbh->query($query)) {
      die("ezt_record: Query failed, aborted.");
    }
    $dbh->next_record();
    return $dbh->record();
    break;
  case 2: // UPDATE
    if(empty($where)) {
      die("ezt_record: Excessive UPDATE, aborted.");
    }
    $query = sprintf("UPDATE %s SET %s WHERE %s", $table, $setpairs, $where);
    break;
  case 3: // DELETE
    if(empty($where)) {
      die("ezt_record: Excessive DELETE, aborted.");
    }
    $query = sprintf("DELETE FROM %s WHERE %s", $table, $where);
    break;
  }

  if(!$dbh->query($query)) {
    die("ezt_record: Query failed, aborted.");
  }
}



function add_ticks($val) {
  return sprintf("'%s'", $val);
}

function add_quotes($val) {
  return sprintf("\"%s\"", $val);
}


function lookup_record($dbh, $query) {
  $stack = array();
  if(!$dbh->query($query)) {
    die("ezt_record: Query failed, aborted.");
  }
  while( $dbh->next_record() ) {
    array_push($stack, $dbh->record());
  }
  return $stack;
}

function lookup_record_array($dbh, $query) {
  $stack = array();
  if(!$dbh->query($query)) {
    die("ezt_record: Query failed, aborted.");
  }
  while( $dbh->next_record() ) {
    $stack = array_merge($stack, $dbh->record());
  }
  return $stack;
}

function ticket_creator($dbh, $ticket_id) {
  return array_pop(array_pop(lookup_record($dbh, sprintf("SELECT ticket_creator_id FROM ezt_tickets WHERE ticket_id = %s", $ticket_id))));
}

function ticket_status($dbh, $ticket_id) {
  return array_pop(array_pop(lookup_record($dbh, sprintf("SELECT ticket_status FROM ezt_tickets WHERE ticket_id = %s", $ticket_id))));
}

function get_sticky_tickets($dbh, $user_id) {
  $unupdated_sticky_list = array();

  $ticket_list = lookup_record($dbh, sprintf("SELECT
        ticket_owner_username,
        ticket_owner_id,
        ticket_id,
        ticket_status,
        ticket_priority,
        ticket_severity,
        ticket_category,
        DATE_FORMAT(ticket_open_date, '%%m-%%d-%%y') AS ticket_open_date,
        UNIX_TIMESTAMP(ticket_last_update) AS ticket_age_seconds,
        ticket_creator_username,
        ticket_creator_id,
        ticket_updater_username,
        ticket_updater_id,
        ticket_title,
        ticket_sticky,
        ticket_sticky_date
        FROM
        ezt_tickets WHERE ticket_sticky = 1 AND ticket_status != %s", CLOSED));

  while($ticket = array_pop($ticket_list)) {
      $update_list = lookup_record($dbh, sprintf("SELECT update_id FROM ezt_updates WHERE update_ticket_id = %s AND update_user_id = %s AND update_date >= '%s'", $ticket['ticket_id'], $user_id, $ticket['ticket_sticky_date']));
      if(empty($update_list))
        array_push($unupdated_sticky_list, $ticket);
  }
  return $unupdated_sticky_list;
}

function send_page($dbh, $ticket_id, $ticket) {
  global $config;
  $from = $config['paging_from'];

  $owner_id = $ticket['ticket_owner_id'];
  $severity = $ticket['ticket_severity'];
  $priority = $ticket['ticket_priority'];
  $title = $ticket['ticket_title'];
  $query = sprintf("SELECT usr.user_email_pager, pgr.paging_level_type, pgr.paging_level
			FROM 
			ezt_users AS usr INNER JOIN ezt_paging AS pgr ON (usr.user_id = pgr.paging_assigned_id)
			WHERE 
			pgr.paging_user_id = %s AND 
			((pgr.paging_level = %s AND pgr.paging_level_type = 'severity') OR
			(pgr.paging_level = %s AND pgr.paging_level_type = 'priority'))", $owner_id, $severity, $priority);
  $pagelist = lookup_record($dbh, $query);

  // Send the actuall page
  while(list($key, $page)=each($pagelist)) {
    $to = $page['user_email_pager'];
    $subject = sprintf("EZT# %s %s %s New/Updated\n%s",$ticket_id, $page['paging_level_type'], $page['paging_level'], $title);
    $body = sprintf("EZT# %s\nOwner: %s\nTitle: %s\n%s/ezt.php?ticket=%s", $ticket_id, $ticket['ticket_owner_username'], $title, $config['baseurl'], $ticket_id); 
    $xtraheaders = sprintf("From: %s\r\n", $from);
    mail($to, $subject, $body, $xtraheaaders);
  }
}

function get_escalations($dbh, $user_ids) {


  $query = sprintf("SELECT *
                        FROM
                        ezt_escalations 
                        WHERE
                        %s", multi_select("escalation_manager", $user_ids, "OR"));
  $escalationlist = lookup_record($dbh, $query);
  $out_array = array();
  if(!empty($escalationlist)) {
    while(list($key, $rec) = each($escalationlist)) {
      $out = sprintf("(ticket_owner_id = %s ", $rec['escalation_user']);
      if($rec['escalation_type'] == 'priority' && $rec['escalation_level'] != -1)
        $out .= sprintf("AND ticket_priority=%s ", $rec['escalation_level']);
      elseif($rec['escalation_type'] == 'severity' && $rec['escalation_level'] != -1)
        $out .= sprintf("AND ticket_severity=%s ", $rec['escalation_level']);
      $out .= sprintf("AND (UNIX_TIMESTAMP(NOW())-UNIX_TIMESTAMP(ticket_last_update) > %s)) ", $rec['escalation_time_seconds']);
      array_push($out_array, $out);
    }
  }
  return $out_array;
}

function get_categories($dbh) {

  $array = lookup_record($dbh, "SELECT * FROM ezt_category");
  while($val = array_pop($array)) {
    $categories[$val['category_id']] = $val['category_name'];
  }
  return $categories;
}

function special_query($dbh, $input_selection) {
  $special_query = array();

  // Set default max-print
  $ret_array['query_limit'] = 50;
  $ret_array['uery_limit_sql'] = "LIMIT " . $ret_array['query_limit'];
  $ret_array['template_replace']['DEFAULT_MAX-PRINT'] = $ret_array['query_limit'];

  // Get ticket ids, and create special query for ezt_updates search
  if(($input_selection['search_updates'] == "1" || $input_selection['search_titles'] == "1") && !empty($input_selection['search'])) {
    $query = "CREATE TEMPORARY TABLE search_temp
                (search_ticket_id INT)";
    $raw_results = lookup_record($dbh, $query);
                                                                                                                                                            
    if($input_selection['search_updates'] == 1) {
      $query = sprintf(" INSERT INTO search_temp
                          SELECT update_ticket_id AS search_ticket_id
                          FROM ezt_updates
                          WHERE update_text LIKE '%%%s%%'
                          ORDER BY search_ticket_id", $input_selection['search']);
      $raw_results = lookup_record($dbh, $query);
    }
                                                                                                                                                            
    if($input_selection['search_titles'] == "1") {
      $query = sprintf(" INSERT INTO search_temp
                          SELECT ticket_id AS search_ticket_id
                          FROM ezt_tickets
                          WHERE ticket_title LIKE '%%%s%%'
                          ORDER BY search_ticket_id", $input_selection['search']);
      $raw_results = lookup_record($dbh, $query);
    }
                                                                                                                                                            
    $ret_array['join_string'] = "INNER JOIN search_temp ON (search_temp.search_ticket_id = ezt_tickets.ticket_id) ";
    $ret_array['group_string'] = "GROUP BY ticket_id";
  }



  $ret_array['selected_creator_id'] = array();
  $ret_array['selected_owner_id'] = array();
  $ret_array['selected_updater_id'] = array();

  // Special query for ezt_tickets
    while(list($key, $val) = each($input_selection)) {
      switch(true) {
        case ($key == "owner" && !empty($val[0])):
          $ret_array['selected_owner_id'] = $val;
	  if ($input_selection['escalations']) {
            $owner_query = get_escalations($dbh, $ret_array['selected_owner_id']);
            $ret_array['template_replace']['ESCALATIONS_SELECTED'] = "CHECKED";
	  } else
	    $owner_query = array();
          array_push($owner_query, multi_select("ticket_owner_id", $ret_array['selected_owner_id'], "OR"));
          array_push($special_query, multi_select_combine($owner_query, "OR"));
          break;
        case ($key == "creator" && !empty($val[0])):
          array_push($special_query, multi_select("ticket_creator_id", $val, "OR"));
          $ret_array['selected_creator_id'] = $val;
          break;
        case ($key == "updater" && !empty($val[0])):
          array_push($special_query, multi_select("ticket_updater_id", $val, "OR"));
          $ret_array['selected_updater_id'] = $val;
          break;
        case ($key == "max-print" && !empty($val)):
          $ret_array['template_replace']['DEFAULT_MAX-PRINT'] = $val;
          $ret_array['query_limit'] = $val;
          break;
        case ($key == "sticky" && !empty($val)):
          array_push($special_query, "ticket_sticky = 1");
          $ret_array['template_replace']['STICKY_SELECTED'] = "CHECKED";
          break;
        case ($key == "summary" && $val == 1):
          if (strlen($ret_array['join_string']) > 0)
            $ret_array['join_string'] .= ", ";
          $ret_array['join_string'] .= "INNER JOIN ezt_updates ON (ezt_tickets.ticket_id = ezt_updates.update_ticket_id) ";
          $ret_array['extra_fields'] .= ", update_text";
          if (empty($ret_array['group_string']))
            $ret_array['group_string'] = "GROUP BY ticket_id";
          break;
        case ($key == "status" && $val[0] != ""):
          array_push($special_query, multi_select("ticket_status", $val, "OR"));
	  foreach($val as $stat) {
            switch($stat) {
              case OPEN:
                $ret_array['template_replace']['OPEN_SELECTED'] = "SELECTED";
                break;
              case DONE:
                $ret_array['template_replace']['DONE_SELECTED'] = "SELECTED";
                break;
              case CLOSED:
                $ret_array['template_replace']['CLOSED_SELECTED'] = "SELECTED";
                break;
	    }
          }
          break;
        case ($key == "priority" && $val[0] != ""):
          array_push($special_query, multi_select("ticket_priority", $val, "OR"));
          $ret_array['selected_priority'] = $val;
          break;
        case ($key == "severity" && $val[0] != ""):
          array_push($special_query, multi_select("ticket_severity", $val, "OR"));
          $ret_array['selected_severity'] = $val;
          break;
        case ($key == "category" && $val[0] != ""):
          array_push($special_query, multi_select("ticket_category", $val, "OR"));
          $ret_array['template_replace']['SELECTED_CATEGORY'] = $val;
          break;
        case ($key == "search" && $val != ""):
          $ret_array['template_replace']['SEARCH_TEXT'] = $val;
          break;
        case ($key == "sort" && $val != ""):
          switch($val) {
            case "severity":
              $ret_array['order_string'] = "ORDER BY ticket_severity";
              $ret_array['template_replace']["SORT_SEVERITY_SELECTED"] = "SELECTED";
              break;
            case "priority":
              $ret_array['order_string'] = "ORDER BY ticket_priority";
              $ret_array['template_replace']["SORT_PRIORITY_SELECTED"] = "SELECTED";
              break;
            case "id":
              $ret_array['order_string'] = "ORDER BY ticket_id";
              $ret_array['template_replace']["SORT_ID_SELECTED"] = "SELECTED";
              break;
            case "owner":
              $ret_array['order_string'] = "ORDER BY ticket_owner_username";
              $ret_array['template_replace']["SORT_OWNER_SELECTED"] = "SELECTED";
              break;
            case "creator":
              $ret_array['order_string'] = "ORDER BY ticket_creator_username";
              $ret_array['template_replace']["SORT_CREATOR_SELECTED"] = "SELECTED";
              break;
            case "updated":
              $ret_array['order_string'] = "ORDER BY ticket_last_update DESC";
              $ret_array['template_replace']["SORT_UPDATED_SELECTED"] = "SELECTED";
              break;
            case "category":
              $ret_array['order_string'] = "ORDER BY ticket_category";
              $ret_array['template_replace']["SORT_CATEGORY_SELECTED"] = "SELECTED";
              break;
          }
          $selected_sort = $val;
          break;
      }
    }

  if (count($special_query) > 0) {
    $ret_array['special_query_string'] = "WHERE "; 
    $ret_array['special_query_string'] .= multi_select_combine($special_query, "AND");
  }

  // Get the page offset
  // Note, we can't do this in the above loop because it depends on max-print being set
  if($input_selection['page'] > 0 && $ret_array['query_limit'] > 0) {
    $ret_array['query_offset'] = sprintf("%s,", ($input_selection['page'] - 1) * $ret_array['query_limit']);
    $ret_array['current_page'] = $input_selection['page'] - 1;
    $ret_array['query_limit_sql'] = "LIMIT " . $ret_array['query_offset'] . $ret_array['query_limit'];
  } elseif ($ret_array['query_limit'] > 0) {
    $ret_array['query_limit_sql'] .= "LIMIT " . $ret_array['query_limit'];
  }

  return $ret_array;
}


function multi_select($field, $selections, $operator) {
  $query = "(";
  $count = count($selections);
  foreach($selections as $element) {
    if ($element != "") {
      $query .= sprintf("%s = %s", $field, $element);
      if ($count > 1)
        $query .= " $operator ";
    }
    $count--;
  }
  $query .= ")";

  return $query;
}

function multi_select_combine($selections, $operator) {
  $query = "(";
  $count = count($selections);
  foreach($selections as $element) {
    if ($element != "") {
      $query .= $element;
      if ($count > 1)
        $query .= " $operator ";
    }
    $count--;
  }
  $query .= ")";
  return $query;
}

// We're looking for ALL key/value pairs to match, if any DO NOT
// match, reutrn FALSE
function match_all_array($needle, $stack) {
  $match = true; 
  foreach ($needle as $key => $val)
    if ($stack[$key] != $val)
      $match = false;
  return $match;
}

// We're looking for any record that matches the needle, if so,
// then return TRUE
function multi_array_match($needle, $stack) {
  $out = array();
  foreach ($stack as $record)
    if (match_all_array($needle, $record))
      array_push($out, $record);
  if (count($out) > 0)
    return $out;
  else
    return false;
}

?>
