<?php

$ezt_root_path='/u/ezt';
if (!is_file($ezt_root_path . "/ptr/loaddata.lock")) {
  print "disabled to prevent DB corruption -KAG";
  exit;
}

print "<pre>";

// Get our mimetypes for attachments
$file = file('/etc/mime.types');
foreach($file as $line) {
  rtrim($line);
  if (preg_match('/^\#/', $line))
    continue;
  $elms = preg_split('/\s+/', $line);
  $type = array_shift($elms);
  foreach ($elms as $elm) {
    $mime[$elm] = $type;
  }
}

function get_file_type($filename) {
  global $mime;

  ereg( ".*\.([a-zA-z0-9]{0,5})$", trim($filename), $regs );
  $f_ext = strtolower($regs[1]);

  if(empty($f_ext))
    return "application/octet-stream";

  $mimetype = $mime[$f_ext];
  if(empty($mimetype))
    $mimetype = "application/octet-stream";
  return $mimetype;
}


function process_attachments($attachments, $ticket_id) {
  global $config, $q, $totattach, $count, $debug;

  for ($i = 1; $i <= $attachments; $i++) {
    $descfile = sprintf("%s/ptr/ptr-attach/%s/desc%s.att", $config['basedir'], $ticket_id, $i);
    if(is_file($descfile)) {
      #$attachment['attachment_date'] = "NOW()";
      $attachment['attachment_date'] = add_ticks(date("%Y-%m-%d %H:%i:%s", filemtime($descfile)));
      $attachment['attachment_ticket_id'] = add_ticks($ticket_id);

      // Read in the description
      $attachment['attachment_description'] = fread(fopen ($descfile, "r"), filesize($descfile));

      // Test for new or old PTR attachment method
      $attfile = sprintf("%s/ptr/ptr-attach/%s/file%s.att", $config['basedir'], $ticket_id, $i);
      if(!is_file($attfile)) {
        // New PTR attachment method, Get attachment filename from the desc file
        $attachment['attachment_filename'] = $attachment['attachment_description'];
        $attfile = sprintf("%s/ptr/ptr-attach/%s/%s", $config['basedir'], $ticket_id, $attachment['attachment_filename']);
      }

      // Get attachment and stick it in our blob
      if(is_file($attfile)) {
	$attachment['attachment_blob'] = addslashes(fread(fopen($attfile, "rb"), filesize($attfile)));
#        $handle = fopen ($attfile, "r");
#        while(!feof($handle)) {
#          $attachment['attachment_blob'] .= fread($handle, 1024);
#        }
#        fclose ($handle);
      } else {
        die("$ticket_id - $attfile - missing attachment file!");
      }

      // We're using mysql 3, we can't load anything bigger than 16 Meg!  Truncate the file (yes, i know it sucks)
      if(strlen($attachment['attachment_blob']) > 16000000) {
        $attachment['attachment_blob'] = substr($attachment['attachment_blob'], 0, 16000000);
      }

      $attachment['attachment_type'] = add_ticks(addslashes(get_file_type($attachment['attachment_filename'])));
      $attachment['attachment_size'] = add_ticks(strlen($attachment['attachment_blob']));
      $attachment['attachment_description'] = add_ticks(addslashes($attachment['attachment_description']));
      $attachment['attachment_filename'] = add_ticks(addslashes($attachment['attachment_filename']));
      $attachment['attachment_blob'] = add_ticks($attachment['attachment_blob']);

#printf("$descfile - $attfile - %s\n", strlen($attachment['attachment_blob']));
      $new_attachment_id = ezt_record($q, "ezt_attachments", $attachment, INSERT);

      print "A";
      $totattach++;
      if (($count+($totattach*10)) % 2500 == 0 && $debug != 1) {
        print "\n";
      }

      unset($attachment);

    } else {
      die("$ticket_id - $descfile - missing attachment description!");
    }
  }
}


define('EXEC_EZT', true);
$ezt_root_path='/u/ezt';
include("../common.php");


print "<html><head><title>Load Tickets to Mysql DB</title></head><body><pre>";
print "connecting to database....\n";

$q = new ezt_db;

print "test select command....\n";
 $query = sprintf("SELECT * FROM ezt_tickets");
 $q->query($query);

printf("%s rows selected\n\n", $q->num_rows());




print "purging tables....\n";
$query = sprintf("DELETE FROM ezt_tickets");
$q->query($query);

$query = sprintf("DELETE FROM ezt_attachments");
$q->query($query);




print "parsing ptr.db and inserting into database....\n";
print "<font size=1>\n";
$handle = fopen ("../ptr/ptr.db", "r");
unset($ticket);
$count=1;
$totattach=1;

$debug=0;

//while ((!feof ($handle)) && ($count<100)) {
while (!feof ($handle)) {
    $buffer = trim(fgets($handle, 4096));
if ($debug == 1) print "l";

    if($buffer == "-- WRITE --") {
if ($debug == 1) print "W\n";
      $query = sprintf("INSERT INTO ezt_tickets SET ");
 
      while (list($key, $val)=each($ticket)) {
        $query .= sprintf("%s=%s, ", $key, $val);
      }
      $query .= sprintf("ticket_id='%s'",$count);
 
//      printf("query=%s\n",$query);
//      printf("ticket=%s\n",print_r($ticket));

      $q->query($query);
      unset($ticket);
      $count++;
#if ($debug == 1 && $count % 250 == 0) print "/n";
      if ($count % 10 == 0 && $debug != 1) {
        print "#";
      }
      if (($count+($totattach*10)) % 2500 == 0 && $debug != 1) {
        print "\n";
      }
if ($debug == 1) print "$count - ";
      
    } else {
      list($ctrl,$data) = split("=", $buffer, 2);
      switch ($ctrl) {
        case "cr":
          if ($debug == 1) print "o";
          $ticket["ticket_open_date"]=sprintf("FROM_UNIXTIME('%s')", $data);
          break;
        case "up":
          if ($debug == 1) print "u";
          $ticket['ticket_last_update']=sprintf("FROM_UNIXTIME('%s')", $data);
          break;
        case "ct":
          if ($debug == 1) print "c";
          $ticket['ticket_category']=sprintf("'%s'", $data);
          break;
        case "pr":
          if ($debug == 1) print "p";
          $ticket['ticket_priority']=sprintf("'%s'", $data);
          break;
        case "at":
          if ($debug == 1) print "a";
          process_attachments($data, $count);
          break;
        case "st":
          if ($debug == 1) print "s";
          switch ($data) {
            case "O":
              $ticket['ticket_status']=OPEN;
              break;
            case "D":
              $ticket['ticket_status']=DONE;
              break;
            case "C":
              $ticket['ticket_status']=CLOSED;
              break;
	  }
        break;
        case "cv":
          if ($debug == 1) print "v";
          $ticket['ticket_severity']=sprintf("'%s'", $data);
          break;
        case "c":
          if ($debug == 1) print "u";
          $ticket['ticket_creator_username']=sprintf("'%s'", $data);
          $query = sprintf("SELECT * FROM ezt_users WHERE user_username='%s'", $data);
          $q->query($query);
          if($q->num_rows() == 1) {
            $q->next_record();
            $ticket['ticket_creator_id']=$q->f("user_id");
          } elseif($q->num_rows() > 1) {
	    die("too many usernames!");
          }
          break;
        case "u":
          if ($debug == 1) print "d";
          $ticket['ticket_updater_username']=sprintf("'%s'", $data);
          $query = sprintf("SELECT * FROM ezt_users WHERE user_username='%s'", $data);
          $q->query($query);
          if($q->num_rows() == 1) {
            $q->next_record();
            $ticket['ticket_updater_id']=$q->f("user_id");
          } elseif($q->num_rows() > 1) {
	    die("too many usernames!");
          }
          break;
        case "o":
          if ($debug == 1) print "w";
          $ticket['ticket_owner_username']=sprintf("'%s'", $data);
          $query = sprintf("SELECT * FROM ezt_users WHERE user_username='%s'", $data);
          $q->query($query);
          if($q->num_rows() == 1) {
            $q->next_record();
            $ticket['ticket_owner_id']=$q->f("user_id");
          } elseif($q->num_rows() > 1) {
	    die("too many usernames!");
          }
          break;
        case "t":
          if ($debug == 1) print "t";
          $ticket['ticket_title']=sprintf("'%s'", addslashes($data));
          break;
      }
    }
}

fclose ($handle);

print "</font>\n";
printf("Total inserts: %s\n", $count);
printf("Total attachments: %s", $totattach);

print "</pre></body></html>";
 ?>
