<?php

define('EXEC_EZT', true);
$ezt_root_path='.';
include("./common.php");

$login_url = $config['baseurl'] . $_SERVER['url'];
page_open(array("sess" => "ezt_Session", "auth" => "ezt_Default_Auth"));

// Set Skin
include("./select-skin.php");

$q = new ezt_db;
$t = new Template($selected_skin['path']);
//$t->debug = 7; /* activate for full debugging */
$t->set_file("page", $selected_skin['new-ezt']);

// touch user record for last login time
$user_update['where'] = array("user_id" => $auth->auth['uid']);
$user_update['user_last_login'] = "NOW()";
ezt_record($q, "ezt_users", $user_update, UPDATE);

// Generate our headers
$Page_name = "New EZTicket";
$headerout=makeheader($q, "$Page_name");
$footerout=makefooter();


// ************************
// *** Ticket creation form
// ************************
if(!isset($_POST['createticket'])) {

  // Get the categories list
  $category_list = lookup_record($q, "SELECT category_id, category_name FROM ezt_category ORDER BY category_name");

  $t->set_block("page", "category-list", "categories");
  while ($element = array_shift($category_list)) {;
    $t->set_var(upper_key($element));
    $t->parse("categories", "category-list", true);
  }

  // get userlist for owners
  $user_list = lookup_record($q, "SELECT user_id, user_username FROM ezt_users ORDER BY user_username");

  $t->set_block("page", "user-list", "users");
  while ($element = array_shift($user_list)) {;
    $t->set_var(upper_key($element));
    $t->parse("users", "user-list", true);
  }

  // Severity
  $t->set_block("page", "severity-list", "severities");
  foreach($severity_levels as $key => $sev) {
    if($config['default_severity'] == $sev)
      $t->set_var("SEVERITY_SELECTED", "SELECTED");
    else
      $t->set_var("SEVERITY_SELECTED", "");
    $t->set_var("SEVERITY", $sev);
    $t->parse("severities", "severity-list", true);
  }

  // Priority
  $t->set_block("page", "priority-list", "priorities");
  foreach($priority_levels as $key => $sev) {
    if($config['default_priority'] == $sev)
      $t->set_var("PRIORITY_SELECTED", "SELECTED");
    else
      $t->set_var("PRIORITY_SELECTED", "");
    $t->set_var("PRIORITY", $sev);
    $t->parse("priorities", "priority-list", true);
  }
} else {

// ************************
// *** SQL ticket insert
// ************************

  if ($config['readonly'] == 1) {
    error_message("System is in READ ONLY MODE!  Please make your updates later.");
  }

  // Check for bad data
  if (empty($_POST['owner'])) {
    error_message("Please select an OWNER of this ticket!");
  }
  if (empty($_POST['category'])) {
    error_message("Please select a CATEGORY of this ticket!");
  }
  if ($_POST['title'] == "CHANGE TITLE" || empty($_POST['title'])) {
    error_message("Please give this ticket a TITLE!");
  }

  // Lookup user info for DB update
  $owner_user_rec = array_pop(lookup_record($q, sprintf("SELECT user_username FROM ezt_users WHERE user_id = %s", $_POST['owner'])));
  $updater_uid = $auth->auth['uid'];
  $updater_record = array_pop(lookup_record($q, sprintf("SELECT user_username FROM ezt_users WHERE user_id = %s", $auth->auth['uid'])));

  // Map fields to Tickets Database
  $new_ezt_ticket['ticket_title'] = add_ticks($_POST['title']);
  $new_ezt_ticket['ticket_status'] = add_ticks($_POST['status']);
  $new_ezt_ticket['ticket_category'] = add_ticks($_POST['category']);
  $new_ezt_ticket['ticket_severity'] = add_ticks($_POST['severity']);
  $new_ezt_ticket['ticket_priority'] = add_ticks($_POST['priority']);
  $new_ezt_ticket['ticket_sticky'] = add_ticks($_POST['ticket_sticky']);

  $new_ezt_ticket['ticket_creator_id'] = $updater_uid;
  $new_ezt_ticket['ticket_creator_username'] = add_ticks($updater_record['user_username']);
  $new_ezt_ticket['ticket_owner_id'] = add_ticks($_POST['owner']);
  $new_ezt_ticket['ticket_owner_username'] = add_ticks($owner_user_rec['user_username']);
  $new_ezt_ticket['ticket_updater_id'] = $updater_uid;
  $new_ezt_ticket['ticket_updater_username'] = add_ticks($updater_record['user_username']);

  $new_ezt_ticket['ticket_open_date'] = "NOW()";
  $new_ezt_ticket['ticket_last_update'] = "NOW()";

  // Preform insert into ticket table
  $new_ticket_id = array_pop(ezt_record($q, "ezt_tickets", $new_ezt_ticket, INSERT));

  // Map fields to Updates Database
  $new_ezt_update['update_user_id'] = $updater_uid;
  $new_ezt_update['update_username'] = add_ticks($updater_record['user_username']);
  $new_ezt_update['update_ip'] = add_ticks($_SERVER["REMOTE_ADDR"]);
  $new_ezt_update['update_owner_username'] = add_ticks($owner_user_rec['user_username']);
  $new_ezt_update['update_owner_id'] = add_ticks($_POST['owner']);

  $new_ezt_update['update_ticket_id'] = add_ticks($new_ticket_id);
  $new_ezt_update['update_status'] = add_ticks($_POST['status']);
  $new_ezt_update['update_severity'] = add_ticks($_POST['severity']);
  $new_ezt_update['update_priority'] = add_ticks($_POST['priority']);
  $new_ezt_update['update_category'] = add_ticks($_POST['category']);
  $new_ezt_update['update_text'] = add_ticks($_POST['text']);

  $new_ezt_update['update_date'] = "NOW()";

  // Preform insert into ticket table
  $new_update_id = ezt_record($q, "ezt_updates", $new_ezt_update, INSERT);


  send_page($q, $new_ticket_id, $new_ezt_ticket);
  javascript_redirect($config['baseurl'] . "/ezt.php?ticket=" . $new_ticket_id);

}

  // Parse template for final output
  $t->set_var(array("HEADER" => $headerout,
		    "EZTUPDATEJS" => $selected_skin['baseurl'] . "/" . $selected_skin['ezt-updatejs'],
                    "FOOTER" => $footerout,
                    "BASEURL" => $config['baseurl']));
  $t->parse("pageout", "page");
  $output=$t->retp("pageout");
  if($config['templatedebug']) {
     $output .= "Undefied template variables in page:" . @implode(", ", $t->get_undefined("pageout"));
  }
  print $output;
  // Save data back to database.
  page_close()
?>
